# pqxx::icursor_iterator Class Reference

Approximate istream_iterator for icursorstream. More...

`#include <cursor.hxx>`

List of all members.

## Public Types

typedef icursorstream | istream_type
typedef istream_type::size_type | size_type
typedef istream_type::difference_type | difference_type

## Public Member Functions

| icursor_iterator () throw ()
| icursor_iterator (istream_type &) throw ()
| icursor_iterator (const icursor_iterator &) throw ()
| ~icursor_iterator () throw ()
const result & | operator * () const
const result * | operator-> () const
icursor_iterator & | operator++ ()
icursor_iterator | operator++ (int)
icursor_iterator & | operator+= (difference_type)
icursor_iterator & | operator= (const icursor_iterator &) throw ()
bool | operator== (const icursor_iterator &rhs) const
bool | operator!= (const icursor_iterator &rhs) const throw ()
bool | operator< (const icursor_iterator &rhs) const
bool | operator> (const icursor_iterator &rhs) const
bool | operator<= (const icursor_iterator &rhs) const
bool | operator>= (const icursor_iterator &rhs) const

## Friends

class | icursorstream

## Detailed Description

Approximate istream_iterator for icursorstream.

Intended as an implementation of an input_iterator (as defined by the C++ Standard Library), this class supports only two basic operations: reading the current element, and moving forward. In addition to the minimal guarantees for istream_iterators, this class supports multiple successive reads of the same position (the current result set is cached in the iterator) even after copying and even after new data have been read from the stream. This appears to be a requirement for input_iterators. Comparisons are also supported in the general case.

The iterator does not care about its own position, however. Moving an iterator forward moves the underlying stream forward and reads the data from the new stream position, regardless of the iterator's old position in the stream.

The stream's stride defines the granularity for all iterator movement or access operations, i.e. "<tt>ici += 1</tt>" advances the stream by one stride's worth of tuples, and "<tt>*ici++</tt>" reads one stride's worth of tuples from the stream.

Warning:
  Do not read from the underlying stream or its cursor, move its read position, or change its stride, between the time the first icursor_iterator on it is created and the time its last icursor_iterator is destroyed.

  Manipulating these iterators within the context of a single cursor stream is not thread-safe. Creating a new iterator, copying one, or destroying one affects the stream as a whole.

## Member Typedef Documentation

typedef icursorstream pqxx::icursor_iterator::istream_type

typedef istream_type::size_type pqxx::icursor_iterator::size_type

typedef istream_type::difference_type pqxx::icursor_iterator::difference_type

## Constructor & Destructor Documentation

pqxx::icursor_iterator::icursor_iterator | ( |  | ) | throw ()

pqxx::icursor_iterator::icursor_iterator | ( | istream_type & |  | ) | throw ()`[explicit]`

pqxx::icursor_iterator::icursor_iterator | ( | const icursor_iterator & |  | ) | throw ()

pqxx::icursor_iterator::~icursor_iterator | ( |  | ) | throw ()

## Member Function Documentation

const result& pqxx::icursor_iterator::operator * | ( |  | ) | const

const result* pqxx::icursor_iterator::operator-> | ( |  | ) | const

pqxx::icursor_iterator & pqxx::icursor_iterator::operator++ | ( |  | ) |

pqxx::icursor_iterator pqxx::icursor_iterator::operator++ | ( | int |  | ) |

pqxx::icursor_iterator & pqxx::icursor_iterator::operator+= | ( | difference_type |  | ) |

pqxx::icursor_iterator & pqxx::icursor_iterator::operator= | ( | const icursor_iterator & |  | ) | throw ()

bool pqxx::icursor_iterator::operator== | ( | const icursor_iterator & | rhs | ) | const

bool pqxx::icursor_iterator::operator!= | ( | const icursor_iterator & | rhs | ) | const throw ()

bool pqxx::icursor_iterator::operator< | ( | const icursor_iterator & | rhs | ) | const

bool pqxx::icursor_iterator::operator> | ( | const icursor_iterator & | rhs | ) | const

bool pqxx::icursor_iterator::operator<= | ( | const icursor_iterator & | rhs | ) | const

bool pqxx::icursor_iterator::operator>= | ( | const icursor_iterator & | rhs | ) | const

## Friends And Related Function Documentation

friend class icursorstream `[friend]`

The documentation for this class was generated from the following files:

- cursor.hxx
- cursor.cxx